describe("GridLayer",(function(){var e,t;beforeEach((function(){(e=document.createElement("div")).style.width="800px",e.style.height="600px",e.style.visibility="hidden",document.body.appendChild(e),t=L.map(e)})),afterEach((function(){document.body.removeChild(e)})),describe("#redraw",(function(){it("can be called before map.setView",(function(){var e=L.gridLayer().addTo(t);expect(e.redraw()).to.equal(e)}))})),describe("#setOpacity",(function(){it("can be called before map.setView",(function(){var e=L.gridLayer().addTo(t);expect(e.setOpacity(.5)).to.equal(e)})),it("works when map has fadeAnimated=false (IE8 is exempt)",(function(o){t.remove(),t=L.map(e,{fadeAnimation:!1}).setView([0,0],0);var i=L.gridLayer().setOpacity(.5).addTo(t);i.on("load",(function(){expect(i._container.style.opacity).to.equal("0.5"),o()}))}))})),it("positions tiles correctly with wrapping and bounding",(function(){t.setView([0,0],1);var e=[],o=L.gridLayer();o.createTile=function(t){var o=document.createElement("div");return e.push({coords:t,tile:o}),o},t.addLayer(o);for(var i={},a=0;a<e.length;a++){var n=e[a].coords,l=L.DomUtil.getPosition(e[a].tile);i[l.x+":"+l.y]=[n.x,n.y]}expect(i).to.eql({"144:0":[0,0],"400:0":[1,0],"144:256":[0,1],"400:256":[1,1],"-112:0":[1,0],"656:0":[0,0],"-112:256":[1,1],"656:256":[0,1]})})),describe("tile pyramid",(function(){var o;beforeEach((function(){o=sinon.useFakeTimers()})),afterEach((function(){o.restore()})),it("removes tiles for unused zoom levels",(function(i){t.remove(),(t=L.map(e,{fadeAnimation:!1})).setView([0,0],1);var a=L.gridLayer(),n={};a.createTile=function(e){return n[a._tileCoordsToKey(e)]=!0,document.createElement("div")},a.on("tileunload",(function(e){delete n[a._tileCoordsToKey(e.coords)]})),a.on("load",(function(e){1===Object.keys(n).length&&(expect(Object.keys(n)).to.eql(["0:0:0"]),a.off(),i())})),t.addLayer(a),t.setZoom(0,{animate:!1}),o.tick(250)}))})),describe("#createTile",(function(){beforeEach((function(){e.style.width="512px",e.style.height="512px"})),afterEach((function(){e.style.width="800px",e.style.height="600px"})),it("only creates tiles for visible area on zoom in",(function(o){t.remove(),(t=L.map(e)).setView([0,0],10);var i=L.gridLayer(),a=0,n=0;i.createTile=function(e){return a++,document.createElement("div")};i.on("load",(function(e){expect(a).to.eql(4),a=0,1===++n?t.zoomIn():o()})),t.addLayer(i)}))})),describe("#onAdd",(function(){it("is called after zoomend on first map load",(function(){var e=L.gridLayer().addTo(t),o=e.onAdd,i=sinon.spy();e.onAdd=function(){o.apply(this,arguments),i()};var a=sinon.spy();t.on("zoomend",a),t.setView([0,0],0),expect(a.calledBefore(i)).to.be.ok()}))})),describe("#getMaxZoom, #getMinZoom",(function(){describe("when a tilelayer is added to a map with no other layers",(function(){it("has the same zoomlevels as the tilelayer",(function(){t.setView([0,0],1),L.gridLayer({maxZoom:10,minZoom:5}).addTo(t),expect(t.getMaxZoom()).to.be(10),expect(t.getMinZoom()).to.be(5)}))})),describe("accessing a tilelayer's properties",(function(){it("provides a container",(function(){t.setView([0,0],1);var e=L.gridLayer().addTo(t);expect(e.getContainer()).to.be.ok()}))})),describe("when a tilelayer is added to a map that already has a tilelayer",(function(){it("has its zoomlevels updated to fit the new layer",(function(){t.setView([0,0],1),L.gridLayer({minZoom:10,maxZoom:15}).addTo(t),expect(t.getMinZoom()).to.be(10),expect(t.getMaxZoom()).to.be(15),L.gridLayer({minZoom:5,maxZoom:10}).addTo(t),expect(t.getMinZoom()).to.be(5),expect(t.getMaxZoom()).to.be(15),L.gridLayer({minZoom:10,maxZoom:20}).addTo(t),expect(t.getMinZoom()).to.be(5),expect(t.getMaxZoom()).to.be(20),L.gridLayer({minZoom:0,maxZoom:25}).addTo(t),expect(t.getMinZoom()).to.be(0),expect(t.getMaxZoom()).to.be(25)}))})),describe("when a tilelayer is removed from a map",(function(){it("has its zoomlevels updated to only fit the layers it currently has",(function(){var e=[L.gridLayer({minZoom:10,maxZoom:15}).addTo(t),L.gridLayer({minZoom:5,maxZoom:10}).addTo(t),L.gridLayer({minZoom:10,maxZoom:20}).addTo(t),L.gridLayer({minZoom:0,maxZoom:25}).addTo(t)];t.whenReady((function(){expect(t.getMinZoom()).to.be(0),expect(t.getMaxZoom()).to.be(25),t.removeLayer(e[0]),expect(t.getMinZoom()).to.be(0),expect(t.getMaxZoom()).to.be(25),t.removeLayer(e[3]),expect(t.getMinZoom()).to.be(5),expect(t.getMaxZoom()).to.be(20),t.removeLayer(e[2]),expect(t.getMinZoom()).to.be(5),expect(t.getMaxZoom()).to.be(10),t.removeLayer(e[1]),expect(t.getMinZoom()).to.be(0),expect(t.getMaxZoom()).to.be(1/0)}))}))}))})),describe("number of 256px tiles loaded in synchronous non-animated grid @800x600px",(function(){var e,o,i;beforeEach((function(){e=sinon.useFakeTimers(),(o=L.gridLayer({attribution:"Grid Layer",tileSize:L.point(256,256)})).createTile=function(e){var t=document.createElement("div");return t.innerHTML=[e.x,e.y,e.z].join(", "),t.style.border="2px solid red",t},i={tileload:0,tileerror:0,tileloadstart:0,tileunload:0},o.on("tileload tileunload tileerror tileloadstart",(function(e){i[e.type]++})),t.options.fadeAnimation=!1,t.options.zoomAnimation=!1})),afterEach((function(){e.restore(),o.off(),o=void 0,i=void 0})),it("Loads 8 tiles zoom 1",(function(a){o.on("load",(function(){expect(i.tileloadstart).to.be(8),expect(i.tileload).to.be(8),expect(i.tileunload).to.be(0),a()})),t.addLayer(o).setView([0,0],1),e.tick(250)})),it("Loads 5 tiles zoom 0",(function(a){o.on("load",(function(){expect(i.tileloadstart).to.be(5),expect(i.tileload).to.be(5),expect(i.tileunload).to.be(0),a()})),t.addLayer(o).setView([0,0],0),e.tick(250)})),it("Loads 16 tiles zoom 10",(function(a){o.on("load",(function(){expect(i.tileloadstart).to.be(16),expect(i.tileload).to.be(16),expect(i.tileunload).to.be(0),o.off(),a()})),t.addLayer(o).setView([0,0],10),e.tick(250)})),it("Loads 32, unloads 16 tiles zooming in 10-11",(function(a){o.on("load",(function(){expect(i.tileloadstart).to.be(16),expect(i.tileload).to.be(16),expect(i.tileunload).to.be(0),o.off("load"),o.on("load",(function(){expect(i.tileloadstart).to.be(32),expect(i.tileload).to.be(32),expect(i.tileunload).to.be(16),a()})),t.setZoom(11,{animate:!1}),e.tick(250)})),t.addLayer(o).setView([0,0],10),e.tick(250)})),it("Loads 32, unloads 16 tiles zooming out 11-10",(function(a){o.on("load",(function(){expect(i.tileloadstart).to.be(16),expect(i.tileload).to.be(16),expect(i.tileunload).to.be(0),o.off("load"),o.on("load",(function(){expect(i.tileloadstart).to.be(32),expect(i.tileload).to.be(32),expect(i.tileunload).to.be(16),a()})),t.setZoom(10,{animate:!1}),e.tick(250)})),t.addLayer(o).setView([0,0],11),e.tick(250)})),it("Loads 32, unloads 16 tiles zooming out 18-10",(function(a){o.on("load",(function(){expect(i.tileloadstart).to.be(16),expect(i.tileload).to.be(16),expect(i.tileunload).to.be(0),o.off("load"),o.on("load",(function(){expect(i.tileloadstart).to.be(32),expect(i.tileload).to.be(32),expect(i.tileunload).to.be(16),a()})),t.setZoom(10,{animate:!1}),e.tick(250)})),t.addLayer(o).setView([0,0],18),e.tick(250)}))})),describe("number of 256px tiles loaded in synchronous animated grid @800x600px",(function(){var e,o,i;function a(e){return n(e)()}function n(o){return o?function(){e.tick(40),t.fire("_frame"),L.Util.requestAnimFrame(n(o-1))}:L.Util.falseFn}beforeEach((function(){e=sinon.useFakeTimers(),(o=L.gridLayer({attribution:"Grid Layer",tileSize:L.point(256,256)})).createTile=function(e){var t=document.createElement("div");return t.innerHTML=[e.x,e.y,e.z].join(", "),t.style.border="2px solid red",t},i={tileload:0,tileerror:0,tileloadstart:0,tileunload:0},o.on("tileload tileunload tileerror tileloadstart",(function(e){i[e.type]++}))})),afterEach((function(){e.restore(),o.off(),o=void 0,i=void 0})),it.skipInPhantom("Loads 32, unloads 16 tiles zooming in 10-11",(function(a){o.on("load",(function(){expect(i.tileloadstart).to.be(16),expect(i.tileload).to.be(16),expect(i.tileunload).to.be(0),o.off("load"),o.on("load",(function(){expect(i.tileloadstart).to.be(32),expect(i.tileload).to.be(32),expect(i.tileunload).to.be(0),e.tick(300),expect(i.tileunload).to.be(12),L.Util.requestAnimFrame((function(){expect(i.tileloadstart).to.be(32),expect(i.tileload).to.be(32),expect(i.tileunload).to.be(16),a()}))})),t.setZoom(11,{animate:!0}),e.tick(250)})),t.addLayer(o).setView([0,0],10),e.tick(250)})),it("Loads 32, unloads 16 tiles zooming in 10-18",(function(a){o.on("load",(function(){expect(i.tileloadstart).to.be(16),expect(i.tileload).to.be(16),expect(i.tileunload).to.be(0),o.off("load"),o.on("load",(function(){L.Util.requestAnimFrame((function(){expect(i.tileloadstart).to.be(32),expect(i.tileload).to.be(32),expect(i.tileunload).to.be(16),a()}))})),t.setZoom(18,{animate:!0}),e.tick(250)})),t.addLayer(o).setView([0,0],10),e.tick(250)})),it.skipInPhantom("Loads 32, unloads 16 tiles zooming out 11-10",(function(a){o.on("load",(function(){expect(i.tileloadstart).to.be(16),expect(i.tileload).to.be(16),expect(i.tileunload).to.be(0),o.off("load"),o.on("load",(function(){o.off("load"),expect(i.tileloadstart).to.be(20),expect(i.tileload).to.be(20),expect(i.tileunload).to.be(0),e.tick(300),L.Util.requestAnimFrame((function(){expect(i.tileunload).to.be(16),o.on("load",(function(){expect(i.tileloadstart).to.be(32),expect(i.tileload).to.be(32),a()}))}))})),t.setZoom(10,{animate:!0}),e.tick(250)})),t.addLayer(o).setView([0,0],11),e.tick(250)})),it("Loads 32, unloads 16 tiles zooming out 18-10",(function(a){o.on("load",(function(){expect(i.tileloadstart).to.be(16),expect(i.tileload).to.be(16),expect(i.tileunload).to.be(0),o.off("load"),o.on("load",(function(){L.Util.requestAnimFrame((function(){expect(i.tileloadstart).to.be(32),expect(i.tileload).to.be(32),expect(i.tileunload).to.be(16),a()}))})),t.setZoom(10,{animate:!0}),e.tick(250)})),t.addLayer(o).setView([0,0],18),e.tick(250)})),it.skipInPhantom("Loads 290, unloads 275 tiles on MAD-TRD flyTo()",(function(n){this.timeout(1e4);var l=[63.41,10.41];o.on("load",(function(){expect(i.tileloadstart).to.be(12),expect(i.tileload).to.be(12),expect(i.tileunload).to.be(0),o.off("load"),t.on("zoomend",(function(){expect(i.tileloadstart).to.be(290),expect(i.tileunload).to.be(275),expect(i.tileload).to.be(290),expect(o._container.querySelectorAll("div").length).to.be(16),n()})),t.flyTo(l,12,{animate:!0}),a(500)})),t.addLayer(o).setView([40.4,-3.7],12),e.tick(250)}))})),describe("configurable tile pruning",(function(){var e,o,i;beforeEach((function(){e=sinon.useFakeTimers(),(o=L.gridLayer({attribution:"Grid Layer",tileSize:L.point(256,256)})).createTile=function(e){var t=document.createElement("div");return t.innerHTML=[e.x,e.y,e.z].join(", "),t.style.border="2px solid red",t},i={tileload:0,tileerror:0,tileloadstart:0,tileunload:0},o.on("tileload tileunload tileerror tileloadstart",(function(e){i[e.type]++})),t.options.fadeAnimation=!1,t.options.zoomAnimation=!1})),afterEach((function(){e.restore(),o.off(),o=void 0,i=void 0})),it("Loads map, moves forth by 512 px, keepBuffer = 0",(function(a){o.on("load",(function(){expect(i.tileloadstart).to.be(16),expect(i.tileload).to.be(16),expect(i.tileunload).to.be(0),o.off("load"),o.on("load",(function(){expect(i.tileloadstart).to.be(28),expect(i.tileload).to.be(28),expect(i.tileunload).to.be(12),a()})),t.panBy([512,512],{animate:!1}),e.tick(250)})),o.options.keepBuffer=0,t.addLayer(o).setView([0,0],10),e.tick(250)})),it("Loads map, moves forth and back by 512 px, keepBuffer = 0",(function(a){o.on("load",(function(){expect(i.tileloadstart).to.be(16),expect(i.tileload).to.be(16),expect(i.tileunload).to.be(0),o.off("load"),o.on("load",(function(){expect(i.tileloadstart).to.be(28),expect(i.tileload).to.be(28),expect(i.tileunload).to.be(12),o.off("load"),o.on("load",(function(){expect(i.tileloadstart).to.be(40),expect(i.tileload).to.be(40),expect(i.tileunload).to.be(24),a()})),t.panBy([-512,-512],{animate:!1}),e.tick(250)})),t.panBy([512,512],{animate:!1}),e.tick(250)})),o.options.keepBuffer=0,t.addLayer(o).setView([0,0],10),e.tick(250)})),it("Loads map, moves forth and back by 512 px, default keepBuffer",(function(a){var n=sinon.spy();o.on("load",(function(){expect(i.tileloadstart).to.be(16),expect(i.tileload).to.be(16),expect(i.tileunload).to.be(0),o.off("load"),o.on("load",(function(){expect(i.tileloadstart).to.be(28),expect(i.tileload).to.be(28),expect(i.tileunload).to.be(0),o.off("load"),o.addEventListener("load",n),t.panBy([-512,-512],{animate:!1}),e.tick(250),expect(n.called).to.be(!1),a()})),t.panBy([512,512],{animate:!1}),e.tick(250)})),t.addLayer(o).setView([0,0],10),e.tick(250)}))})),describe("nowrap option",(function(){it("When false, uses same coords at zoom 0 for all tiles",(function(e){var o=L.gridLayer({attribution:"Grid Layer",tileSize:L.point(256,256),noWrap:!1}),i=[];o.createTile=function(e){return i.push(e.x+":"+e.y+":"+e.z),document.createElement("div")},t.addLayer(o).setView([0,0],0),o.on("load",(function(){expect(i).to.eql(["0:0:0","0:0:0","0:0:0","0:0:0","0:0:0"]),e()}))})),it("When true, uses different coords at zoom level 0 for all tiles",(function(e){var o=L.gridLayer({attribution:"Grid Layer",tileSize:L.point(256,256),noWrap:!0}),i=[];o.createTile=function(e){return i.push(e.x+":"+e.y+":"+e.z),document.createElement("div")},t.addLayer(o).setView([0,0],0),o.on("load",(function(){expect(i).to.eql(["0:0:0","-1:0:0","1:0:0","-2:0:0","2:0:0"]),e()}))})),it("When true and with bounds, loads just one tile at zoom level 0",(function(e){var o=L.gridLayer({attribution:"Grid Layer",tileSize:L.point(256,256),bounds:[[-90,-180],[90,180]],noWrap:!0}),i=[];o.createTile=function(e){return i.push(e.x+":"+e.y+":"+e.z),document.createElement("div")},t.addLayer(o).setView([0,0],0),o.on("load",(function(){expect(i).to.eql(["0:0:0"]),e()}))}))}))}));