describe("Map",(function(){var e,o;function t(){var e=new L.Layer;return e.onAdd=sinon.spy(),e.onRemove=sinon.spy(),e}beforeEach((function(){e=L.map(document.createElement("div"))})),describe("#remove",(function(){it("fires an unload event if loaded",(function(){var e=document.createElement("div"),o=new L.Map(e).setView([0,0],0),t=sinon.spy();o.on("unload",t),o.remove(),expect(t.called).to.be.ok()})),it("fires no unload event if not loaded",(function(){var e=document.createElement("div"),o=new L.Map(e),t=sinon.spy();o.on("unload",t),o.remove(),expect(t.called).not.to.be.ok()})),describe("corner case checking",(function(){it("throws an exception upon reinitialization",(function(){var e=document.createElement("div"),o=new L.Map(e);expect((function(){L.map(e)})).to.throwException((function(e){expect(e.message).to.eql("Map container is already initialized.")})),o.remove()})),it("throws an exception if a container is not found",(function(){expect((function(){L.map("nonexistentdivelement")})).to.throwException((function(e){expect(e.message).to.eql("Map container not found.")})),e.remove()}))})),it("undefines container._leaflet",(function(){var e=document.createElement("div");new L.Map(e).remove(),expect(e._leaflet).to.be(void 0)})),it("unbinds events",(function(){var e=document.createElement("div"),o=new L.Map(e).setView([0,0],1),t=sinon.spy();o.on("click dblclick mousedown mouseup mousemove",t),o.remove(),happen.click(e),happen.dblclick(e),happen.mousedown(e),happen.mouseup(e),happen.mousemove(e),expect(t.called).to.not.be.ok()})),it("throws error if container is reused by other instance",(function(){var e=document.createElement("div"),o=L.map(e);o.remove(),L.map(e),expect((function(){o.remove()})).to.throwException()}))})),describe("#getCenter",(function(){it("throws if not set before",(function(){expect((function(){e.getCenter()})).to.throwError()})),it("returns a precise center when zoomed in after being set (#426)",(function(){var o=L.latLng(10,10);e.setView(o,1),e.setZoom(19),expect(e.getCenter()).to.eql(o)})),it("returns correct center after invalidateSize (#1919)",(function(){e.setView(L.latLng(10,10),1),e.invalidateSize(),expect(e.getCenter()).not.to.eql(L.latLng(10,10))}))})),describe("#whenReady",(function(){describe("when the map has not yet been loaded",(function(){it("calls the callback when the map is loaded",(function(){var o=sinon.spy();e.whenReady(o),expect(o.called).to.not.be.ok(),e.setView([0,0],1),expect(o.called).to.be.ok()}))})),describe("when the map has already been loaded",(function(){it("calls the callback immediately",(function(){var o=sinon.spy();e.setView([0,0],1),e.whenReady(o),expect(o.called).to.be.ok()}))}))})),describe("#setView",(function(){it("sets the view of the map",(function(){expect(e.setView([51.505,-.09],13)).to.be(e),expect(e.getZoom()).to.be(13),expect(e.getCenter().distanceTo([51.505,-.09])).to.be.lessThan(5)})),it("can be passed without a zoom specified",(function(){e.setZoom(13),expect(e.setView([51.605,-.11])).to.be(e),expect(e.getZoom()).to.be(13),expect(e.getCenter().distanceTo([51.605,-.11])).to.be.lessThan(5)})),it("limits initial zoom when no zoom specified",(function(){e.options.maxZoom=20,e.setZoom(100),expect(e.setView([51.605,-.11])).to.be(e),expect(e.getZoom()).to.be(20),expect(e.getCenter().distanceTo([51.605,-.11])).to.be.lessThan(5)})),it("defaults to zoom passed as map option",(function(){e=L.map(document.createElement("div"),{zoom:13}),expect(e.setView([51.605,-.11])).to.be(e),expect(e.getZoom()).to.be(13)})),it("passes duration option to panBy",(function(){(e=L.map(document.createElement("div"),{zoom:13,center:[0,0]})).panBy=sinon.spy(),e.setView([51.605,-.11],13,{animate:!0,duration:13}),expect(e.panBy.callCount).to.eql(1),expect(e.panBy.args[0][1].duration).to.eql(13)}))})),describe("#getBounds",(function(){it("is safe to call from within a moveend callback during initial load (#1027)",(function(){e.on("moveend",(function(){e.getBounds()})),e.setView([51.505,-.09],13)}))})),describe("#getBoundsZoom",(function(){var o=25e-5,t=[[-25e-5,-25e-5],[o,o]],n=[100,100],a="400px";it("returns high levels of zoom with small areas and big padding",(function(){var o=e.getContainer();o.style.height=a,document.body.appendChild(o),expect(e.getBoundsZoom(t,!1,n)).to.be.equal(19)})),it("returns multiples of zoomSnap when zoomSnap > 0 on any3d browsers",(function(){var o=e.getContainer();o.style.height=a,document.body.appendChild(o),L.Browser.any3d=!0,e.options.zoomSnap=.5,expect(e.getBoundsZoom(t,!1,n)).to.be.equal(19.5),e.options.zoomSnap=.2,expect(e.getBoundsZoom(t,!1,n)).to.be.equal(19.6),e.options.zoomSnap=0,expect(e.getBoundsZoom(t,!1,n)).to.be.within(19.686456,19.6864561)}))})),describe("#setMaxBounds",(function(){var o;beforeEach((function(){o=e.getContainer(),document.body.appendChild(o)})),afterEach((function(){})),it("aligns pixel-wise map view center with maxBounds center if it cannot move view bounds inside maxBounds (#1908)",(function(){o.style.width=o.style.height="1000px";var t=L.latLngBounds([51.5,-.05],[51.55,.05]);e.setMaxBounds(t,{animate:!1}),e.setView(L.latLng([53,.15]),12,{animate:!1});var n=e.project(t.getCenter()).round();expect(e.project(e.getCenter()).round()).to.eql(n)})),it("moves map view within maxBounds by changing one coordinate",(function(){o.style.width=o.style.height="200px";var t=L.latLngBounds([51,-.2],[52,.2]);e.setMaxBounds(t,{animate:!1});var n=[53,.1];e.setView(L.latLng(n),16,{animate:!1});var a=e.project(e.getCenter()).round(),i=e.project(n).round();expect(a.x).to.eql(i.x),expect(a.y).not.to.eql(i.y),expect(t.contains(e.getBounds())).to.be(!0)})),it("remove listeners when called without arguments",(function(){L.tileLayer("http://tilecache.openstreetmap.fr/hot/{z}/{x}/{y}.png",{minZoom:0,maxZoom:20}).addTo(e),o.style.width=o.style.height="500px";var t=L.latLngBounds([51.5,-.05],[51.55,.05]);e.setMaxBounds(t,{animate:!1}),e.setMaxBounds();var n=L.latLng([0,0]);e.once("moveend",(function(){expect(n.equals(e.getCenter())).to.be(!0)})),e.setView(n,18,{animate:!1})}))})),describe("#getMinZoom and #getMaxZoom",(function(){describe("#getMinZoom",(function(){it("returns 0 if not set by Map options or TileLayer options",(function(){var e=L.map(document.createElement("div"));expect(e.getMinZoom()).to.be(0)}))})),it("minZoom and maxZoom options overrides any minZoom and maxZoom set on layers",(function(){var e=L.map(document.createElement("div"),{minZoom:2,maxZoom:20});L.tileLayer("{z}{x}{y}",{minZoom:4,maxZoom:10}).addTo(e),L.tileLayer("{z}{x}{y}",{minZoom:6,maxZoom:17}).addTo(e),L.tileLayer("{z}{x}{y}",{minZoom:0,maxZoom:22}).addTo(e),expect(e.getMinZoom()).to.be(2),expect(e.getMaxZoom()).to.be(20)})),it("layer minZoom overrides map zoom if map has no minZoom set and layer minZoom is bigger than map zoom",(function(){var e=L.map(document.createElement("div"),{zoom:10});L.tileLayer("{z}{x}{y}",{minZoom:15}).addTo(e),expect(e.getMinZoom()).to.be(15)})),it("layer maxZoom overrides map zoom if map has no maxZoom set and layer maxZoom is smaller than map zoom",(function(){var e=L.map(document.createElement("div"),{zoom:20});L.tileLayer("{z}{x}{y}",{maxZoom:15}).addTo(e),expect(e.getMaxZoom()).to.be(15)})),it("map's zoom is adjusted to layer's minZoom even if initialized with smaller value",(function(){var e=L.map(document.createElement("div"),{zoom:10});L.tileLayer("{z}{x}{y}",{minZoom:15}).addTo(e),expect(e.getZoom()).to.be(15)})),it("map's zoom is adjusted to layer's maxZoom even if initialized with larger value",(function(){var e=L.map(document.createElement("div"),{zoom:20});L.tileLayer("{z}{x}{y}",{maxZoom:15}).addTo(e),expect(e.getZoom()).to.be(15)}))})),describe("#hasLayer",(function(){it("returns false when passed undefined, null, or false",(function(){var e=L.map(document.createElement("div"));expect(e.hasLayer(void 0)).to.equal(!1),expect(e.hasLayer(null)).to.equal(!1),expect(e.hasLayer(!1)).to.equal(!1)}))})),describe("#addLayer",(function(){it("calls layer.onAdd immediately if the map is ready",(function(){var o=t();e.setView([0,0],0),e.addLayer(o),expect(o.onAdd.called).to.be.ok()})),it("calls layer.onAdd when the map becomes ready",(function(){var o=t();e.addLayer(o),expect(o.onAdd.called).not.to.be.ok(),e.setView([0,0],0),expect(o.onAdd.called).to.be.ok()})),it("does not call layer.onAdd if the layer is removed before the map becomes ready",(function(){var o=t();e.addLayer(o),e.removeLayer(o),e.setView([0,0],0),expect(o.onAdd.called).not.to.be.ok()})),it("fires a layeradd event immediately if the map is ready",(function(){var o=t(),n=sinon.spy();e.on("layeradd",n),e.setView([0,0],0),e.addLayer(o),expect(n.called).to.be.ok()})),it("fires a layeradd event when the map becomes ready",(function(){var o=t(),n=sinon.spy();e.on("layeradd",n),e.addLayer(o),expect(n.called).not.to.be.ok(),e.setView([0,0],0),expect(n.called).to.be.ok()})),it("does not fire a layeradd event if the layer is removed before the map becomes ready",(function(){var o=t(),n=sinon.spy();e.on("layeradd",n),e.addLayer(o),e.removeLayer(o),e.setView([0,0],0),expect(n.called).not.to.be.ok()})),it("adds the layer before firing layeradd",(function(o){var n=t();e.on("layeradd",(function(){expect(e.hasLayer(n)).to.be.ok(),o()})),e.setView([0,0],0),e.addLayer(n)})),describe("When the first layer is added to a map",(function(){it("fires a zoomlevelschange event",(function(){var o=sinon.spy();e.on("zoomlevelschange",o),expect(o.called).not.to.be.ok(),L.tileLayer("{z}{x}{y}",{minZoom:0,maxZoom:10}).addTo(e),expect(o.called).to.be.ok()}))})),describe("when a new layer with greater zoomlevel coverage than the current layer is added to a map",(function(){it("fires a zoomlevelschange event",(function(){var o=sinon.spy();L.tileLayer("{z}{x}{y}",{minZoom:0,maxZoom:10}).addTo(e),e.on("zoomlevelschange",o),expect(o.called).not.to.be.ok(),L.tileLayer("{z}{x}{y}",{minZoom:0,maxZoom:15}).addTo(e),expect(o.called).to.be.ok()}))})),describe("when a new layer with the same or lower zoomlevel coverage as the current layer is added to a map",(function(){it("fires no zoomlevelschange event",(function(){var o=sinon.spy();L.tileLayer("{z}{x}{y}",{minZoom:0,maxZoom:10}).addTo(e),e.on("zoomlevelschange",o),expect(o.called).not.to.be.ok(),L.tileLayer("{z}{x}{y}",{minZoom:0,maxZoom:10}).addTo(e),expect(o.called).not.to.be.ok(),L.tileLayer("{z}{x}{y}",{minZoom:0,maxZoom:5}).addTo(e),expect(o.called).not.to.be.ok()}))}))})),describe("#removeLayer",(function(){it("calls layer.onRemove if the map is ready",(function(){var o=t();e.setView([0,0],0),e.addLayer(o),e.removeLayer(o),expect(o.onRemove.called).to.be.ok()})),it("does not call layer.onRemove if the layer was not added",(function(){var o=t();e.setView([0,0],0),e.removeLayer(o),expect(o.onRemove.called).not.to.be.ok()})),it("does not call layer.onRemove if the map is not ready",(function(){var o=t();e.addLayer(o),e.removeLayer(o),expect(o.onRemove.called).not.to.be.ok()})),it("fires a layerremove event if the map is ready",(function(){var o=t(),n=sinon.spy();e.on("layerremove",n),e.setView([0,0],0),e.addLayer(o),e.removeLayer(o),expect(n.called).to.be.ok()})),it("does not fire a layerremove if the layer was not added",(function(){var o=t(),n=sinon.spy();e.on("layerremove",n),e.setView([0,0],0),e.removeLayer(o),expect(n.called).not.to.be.ok()})),it("does not fire a layerremove if the map is not ready",(function(){var o=t(),n=sinon.spy();e.on("layerremove",n),e.addLayer(o),e.removeLayer(o),expect(n.called).not.to.be.ok()})),it("removes the layer before firing layerremove",(function(o){var n=t();e.on("layerremove",(function(){expect(e.hasLayer(n)).not.to.be.ok(),o()})),e.setView([0,0],0),e.addLayer(n),e.removeLayer(n)})),it("supports adding and removing a tile layer without initializing the map",(function(){var o=L.tileLayer("{z}{x}{y}");e.addLayer(o),e.removeLayer(o)})),it("supports adding and removing a tile layer without initializing the map",(function(){e.setView([0,0],18);var o=L.gridLayer();e.addLayer(o),e.removeLayer(o)})),describe("when the last tile layer on a map is removed",(function(){it("fires a zoomlevelschange event",(function(){e.whenReady((function(){var o=sinon.spy(),t=L.tileLayer("{z}{x}{y}",{minZoom:0,maxZoom:10}).addTo(e);e.on("zoomlevelschange",o),expect(o.called).not.to.be.ok(),e.removeLayer(t),expect(o.called).to.be.ok()}))}))})),describe("when a tile layer is removed from a map and it had greater zoom level coverage than the remainding layer",(function(){it("fires a zoomlevelschange event",(function(){e.whenReady((function(){var o=sinon.spy(),t=(L.tileLayer("{z}{x}{y}",{minZoom:0,maxZoom:10}).addTo(e),L.tileLayer("{z}{x}{y}",{minZoom:0,maxZoom:15}).addTo(e));e.on("zoomlevelschange",o),expect(o.called).to.not.be.ok(),e.removeLayer(t),expect(o.called).to.be.ok()}))}))})),describe("when a tile layer is removed from a map it and it had lesser or the sa,e zoom level coverage as the remainding layer(s)",(function(){it("fires no zoomlevelschange event",(function(){e.whenReady((function(){L.tileLayer("{z}{x}{y}",{minZoom:0,maxZoom:10}).addTo(e);var t=L.tileLayer("{z}{x}{y}",{minZoom:0,maxZoom:10}).addTo(e),n=L.tileLayer("{z}{x}{y}",{minZoom:0,maxZoom:5}).addTo(e);e.on("zoomlevelschange",o),expect(o).not.toHaveBeenCalled(),e.removeLayer(t),expect(o).not.toHaveBeenCalled(),e.removeLayer(n),expect(o).not.toHaveBeenCalled()}))}))}))})),describe("#eachLayer",(function(){it("returns self",(function(){expect(e.eachLayer((function(){}))).to.be(e)})),it("calls the provided function for each layer",(function(){var o=L.tileLayer("{z}{x}{y}").addTo(e),t=L.tileLayer("{z}{x}{y}").addTo(e),n=sinon.spy();e.eachLayer(n),expect(n.callCount).to.eql(2),expect(n.firstCall.args).to.eql([o]),expect(n.secondCall.args).to.eql([t])})),it("calls the provided function with the provided context",(function(){L.tileLayer("{z}{x}{y}").addTo(e);var o=sinon.spy();e.eachLayer(o,e),expect(o.thisValues[0]).to.eql(e)}))})),describe("#invalidateSize",(function(){var o,t;beforeEach((function(){(o=e.getContainer()).style.width="100px",document.body.appendChild(o),e.setView([0,0],0),e.invalidateSize({pan:!1}),t=sinon.useFakeTimers()})),afterEach((function(){document.body.removeChild(o),t.restore()})),it("pans by the right amount when growing in 1px increments",(function(){o.style.width="101px",e.invalidateSize(),expect(e._getMapPanePos().x).to.be(1),o.style.width="102px",e.invalidateSize(),expect(e._getMapPanePos().x).to.be(1),o.style.width="103px",e.invalidateSize(),expect(e._getMapPanePos().x).to.be(2)})),it("pans by the right amount when shrinking in 1px increments",(function(){o.style.width="99px",e.invalidateSize(),expect(e._getMapPanePos().x).to.be(0),o.style.width="98px",e.invalidateSize(),expect(e._getMapPanePos().x).to.be(-1),o.style.width="97px",e.invalidateSize(),expect(e._getMapPanePos().x).to.be(-1)})),it("pans back to the original position after growing by an odd size and back",(function(){o.style.width="105px",e.invalidateSize(),o.style.width="100px",e.invalidateSize(),expect(e._getMapPanePos().x).to.be(0)})),it("emits no move event if the size has not changed",(function(){var o=sinon.spy();e.on("move",o),e.invalidateSize(),expect(o.called).not.to.be.ok()})),it("emits a move event if the size has changed",(function(){var t=sinon.spy();e.on("move",t),o.style.width="105px",e.invalidateSize(),expect(t.called).to.be.ok()})),it("emits a moveend event if the size has changed",(function(){var t=sinon.spy();e.on("moveend",t),o.style.width="105px",e.invalidateSize(),expect(t.called).to.be.ok()})),it("debounces the moveend event if the debounceMoveend option is given",(function(){var n=sinon.spy();e.on("moveend",n),o.style.width="105px",e.invalidateSize({debounceMoveend:!0}),expect(n.called).not.to.be.ok(),t.tick(200),expect(n.called).to.be.ok()}))})),describe("#flyTo",(function(){var o;beforeEach((function(){(o=document.createElement("div")).style.width="800px",o.style.height="600px",o.style.visibility="hidden",document.body.appendChild(o),e=L.map(o)})),afterEach((function(){document.body.removeChild(o)})),it("move to requested center and zoom, and call zoomend once",(function(o){this.timeout(1e4);var t=sinon.spy(),n=new L.LatLng(10,11);e.setView([0,0],0),e.on("zoomend",(function(){expect(e.getCenter()).to.eql(n),expect(e.getZoom()).to.eql(12),t(),expect(t.calledOnce).to.be.ok(),o()})).flyTo(n,12)})),it("flyTo start latlng == end latlng",(function(o){this.timeout(1e4);var t=new L.LatLng(38.91,-77.04);e.setView(t,14),e.on("zoomend",(function(){expect(e.getCenter()).to.eql(t),expect(e.getZoom()).to.eql(4),o()})),e.flyTo(t,4)}))})),describe("#zoomIn and #zoomOut",(function(){var o=L.latLng(22,33);beforeEach((function(){e.setView(o,10)})),it("zoomIn zooms by 1 zoom level by default",(function(t){e.once("zoomend",(function(){expect(e.getZoom()).to.eql(11),expect(e.getCenter()).to.eql(o),t()})),e.zoomIn(null,{animate:!1})})),it("zoomOut zooms by 1 zoom level by default",(function(t){e.once("zoomend",(function(){expect(e.getZoom()).to.eql(9),expect(e.getCenter()).to.eql(o),t()})),e.zoomOut(null,{animate:!1})})),it("zoomIn ignores the zoomDelta option on non-any3d browsers",(function(t){L.Browser.any3d=!1,e.options.zoomSnap=.25,e.options.zoomDelta=.25,e.once("zoomend",(function(){expect(e.getZoom()).to.eql(11),expect(e.getCenter()).to.eql(o),t()})),e.zoomIn(null,{animate:!1})})),it("zoomIn respects the zoomDelta option on any3d browsers",(function(t){L.Browser.any3d=!0,e.options.zoomSnap=.25,e.options.zoomDelta=.25,e.setView(o,10),e.once("zoomend",(function(){expect(e.getZoom()).to.eql(10.25),expect(e.getCenter()).to.eql(o),t()})),e.zoomIn(null,{animate:!1})})),it("zoomOut respects the zoomDelta option on any3d browsers",(function(t){L.Browser.any3d=!0,e.options.zoomSnap=.25,e.options.zoomDelta=.25,e.setView(o,10),e.once("zoomend",(function(){expect(e.getZoom()).to.eql(9.75),expect(e.getCenter()).to.eql(o),t()})),e.zoomOut(null,{animate:!1})})),it("zoomIn snaps to zoomSnap on any3d browsers",(function(t){e.options.zoomSnap=.25,e.setView(o,10),e.once("zoomend",(function(){expect(e.getZoom()).to.eql(10.25),expect(e.getCenter()).to.eql(o),t()})),L.Browser.any3d=!0,e.zoomIn(.22,{animate:!1})})),it("zoomOut snaps to zoomSnap on any3d browsers",(function(t){e.options.zoomSnap=.25,e.setView(o,10),e.once("zoomend",(function(){expect(e.getZoom()).to.eql(9.75),expect(e.getCenter()).to.eql(o),t()})),L.Browser.any3d=!0,e.zoomOut(.22,{animate:!1})}))})),describe("#fitBounds",(function(){var o=L.latLng(50.5,30.51),t=L.latLngBounds(L.latLng(1,102),L.latLng(11,122)),n=t.getCenter();beforeEach((function(){var t=e.getContainer();t.style.width=t.style.height="100px",document.body.appendChild(t),e.setView(o,15)})),afterEach((function(){document.body.removeChild(e.getContainer())})),it("Snaps zoom level to integer by default",(function(o){e.once("zoomend",(function(){expect(e.getZoom()).to.eql(2),expect(e.getCenter().equals(n,.05)).to.eql(!0),o()})),e.fitBounds(t,{animate:!1})})),it("Snaps zoom to zoomSnap on any3d browsers",(function(o){e.options.zoomSnap=.25,L.Browser.any3d=!0,e.once("zoomend",(function(){expect(e.getZoom()).to.eql(2.75),expect(e.getCenter().equals(n,.05)).to.eql(!0),o()})),e.fitBounds(t,{animate:!1})})),it("Ignores zoomSnap on non-any3d browsers",(function(o){e.options.zoomSnap=.25,L.Browser.any3d=!1,e.once("zoomend",(function(){expect(e.getZoom()).to.eql(2),expect(e.getCenter().equals(n,.05)).to.eql(!0),o()})),e.fitBounds(t,{animate:!1})})),it("can be called with an array",(function(o){e.once("zoomend",(function(){expect(e.getZoom()).to.eql(2),expect(e.getCenter().equals(n,.05)).to.eql(!0),o()}));e.fitBounds([[1,102],[11,122]],{animate:!1})})),it("throws an error with invalid bounds",(function(){expect((function(){e.fitBounds(NaN)})).to.throwError()})),it("Fits to same scale and zoom",(function(o){var t=e.getBounds(),n=e.getZoom();e.once("moveend zoomend",(function(){var a=e.getBounds();expect(a.getSouthWest()).to.nearLatLng(t.getSouthWest()),expect(a.getNorthEast()).to.nearLatLng(t.getNorthEast()),expect(e.getZoom()).to.eql(n),o()})),e.fitBounds(t,{animate:!1})})),it("Fits to small bounds from small zoom",(function(o){e.once("zoomend",(function(){e.once("zoomend",(function(){expect(e.getZoom()).to.eql(11),expect(e.getCenter().equals(n,.05)).to.eql(!0),o()})),e.fitBounds(t)})),t=L.latLngBounds([57.73,11.93],[57.75,11.95]),n=t.getCenter(),e.setZoom(0)})),it("Fits to large bounds from large zoom",(function(o){e.once("zoomend",(function(){e.once("zoomend",(function(){expect(e.getZoom()).to.eql(0),expect(e.getCenter().equals(n,.05)).to.eql(!0),o()})),e.fitBounds(t)})),t=L.latLngBounds([90,-180],[-90,180]),n=t.getCenter(),e.setZoom(22)}))})),describe("#fitBounds after layers set",(function(){var o=L.latLng(22,33),t=L.latLngBounds(L.latLng(1,102),L.latLng(11,122));t.getCenter();beforeEach((function(){var o=e.getContainer();o.style.width=o.style.height="100px",document.body.appendChild(o)})),afterEach((function(){document.body.removeChild(e.getContainer())})),it("Snaps to a number after adding tile layer",(function(o){L.Browser.any3d=!0,e.addLayer(L.tileLayer("file:///dev/null")),expect(e.getZoom()).to.be(void 0),e.fitBounds(t),expect(e.getZoom()).to.be(2),o()})),it("Snaps to a number after adding marker",(function(n){L.Browser.any3d=!0,e.addLayer(L.marker(o)),expect(e.getZoom()).to.be(void 0),e.fitBounds(t),expect(e.getZoom()).to.be(2),n()}))})),describe("#DOM events",(function(){var e,o;beforeEach((function(){(e=document.createElement("div")).style.width="400px",e.style.height="400px",(o=new L.Map(e)).setView(new L.LatLng(0,0),0),document.body.appendChild(e)})),afterEach((function(){document.body.removeChild(e)})),it("DOM events propagate from polygon to map",(function(){var e=sinon.spy();o.on("mousemove",e);var t=new L.Polygon([[1,2],[3,4],[5,6]]).addTo(o);happen.mousemove(t._path),expect(e.calledOnce).to.be.ok()})),it("DOM events propagate from marker to map",(function(){var e=sinon.spy();o.on("mousemove",e);var t=new L.Marker([1,2]).addTo(o);happen.mousemove(t._icon),expect(e.calledOnce).to.be.ok()})),it("DOM events fired on marker can be cancelled before being caught by the map",(function(){var e=sinon.spy(),t=sinon.spy();o.on("mousemove",e);var n=new L.Marker([1,2]).addTo(o);n.on("mousemove",L.DomEvent.stopPropagation).on("mousemove",t),happen.mousemove(n._icon),expect(t.calledOnce).to.be.ok(),expect(e.called).not.to.be.ok()})),it("DOM events fired on polygon can be cancelled before being caught by the map",(function(){var e=sinon.spy(),t=sinon.spy();o.on("mousemove",e);var n=new L.Polygon([[1,2],[3,4],[5,6]]).addTo(o);n.on("mousemove",L.DomEvent.stopPropagation).on("mousemove",t),happen.mousemove(n._path),expect(t.calledOnce).to.be.ok(),expect(e.called).not.to.be.ok()})),it("mouseout is forwarded if fired on the original target",(function(){var e=sinon.spy(),t=sinon.spy(),n=sinon.spy(),a=new L.Polygon([[1,2],[3,4],[5,6]]).addTo(o),i=new L.Polygon([[10,20],[30,40],[50,60]]).addTo(o);o.on("mouseout",e),a.on("mouseout",t),i.on("mouseout",n),happen.mouseout(a._path,{relatedTarget:o._container}),expect(e.called).not.to.be.ok(),expect(n.called).not.to.be.ok(),expect(t.calledOnce).to.be.ok()})),it("mouseout is forwarded when using a DivIcon",(function(){var e=L.divIcon({html:"<p>this is text in a child element</p>",iconSize:[100,100]}),t=sinon.spy(),n=sinon.spy(),a=L.marker([1,2],{icon:e}).addTo(o);o.on("mouseout",t),a.on("mouseout",n),happen.mouseout(a._icon,{relatedTarget:o._container}),expect(t.called).not.to.be.ok(),expect(n.calledOnce).to.be.ok()})),it("mouseout is not forwarded if relatedTarget is a target's child",(function(){var e=L.divIcon({html:"<p>this is text in a child element</p>",iconSize:[100,100]}),t=sinon.spy(),n=sinon.spy(),a=L.marker([1,2],{icon:e}).addTo(o),i=a._icon.querySelector("p");o.on("mouseout",t),a.on("mouseout",n),happen.mouseout(a._icon,{relatedTarget:i}),expect(t.called).not.to.be.ok(),expect(n.calledOnce).not.to.be.ok()})),it("mouseout is not forwarded if fired on target's child",(function(){var e=L.divIcon({html:"<p>this is text in a child element</p>",iconSize:[100,100]}),t=sinon.spy(),n=sinon.spy(),a=L.marker([1,2],{icon:e}).addTo(o),i=a._icon.querySelector("p");o.on("mouseout",t),a.on("mouseout",n),happen.mouseout(i,{relatedTarget:a._icon}),expect(t.called).not.to.be.ok(),expect(n.calledOnce).not.to.be.ok()})),it("mouseout is not forwarded to layers if fired on the map",(function(){var e=sinon.spy(),t=sinon.spy(),n=sinon.spy(),a=new L.Polygon([[1,2],[3,4],[5,6]]).addTo(o),i=new L.Polygon([[10,20],[30,40],[50,60]]).addTo(o);o.on("mouseout",e),a.on("mouseout",t),i.on("mouseout",n),happen.mouseout(o._container),expect(n.called).not.to.be.ok(),expect(t.called).not.to.be.ok(),expect(e.calledOnce).to.be.ok()})),it("preclick is fired before click on marker and map",(function(){var e=0,t=new L.Marker([1,2]).addTo(o);t.on("preclick",(function(o){expect(e++).to.eql(0),expect(o.latlng).to.ok()})),t.on("click",(function(o){expect(e++).to.eql(2),expect(o.latlng).to.ok()})),o.on("preclick",(function(o){expect(e++).to.eql(1),expect(o.latlng).to.ok()})),o.on("click",(function(o){expect(e++).to.eql(3),expect(o.latlng).to.ok()})),happen.click(t._icon)}))})),describe("#getScaleZoom && #getZoomScale",(function(){it("converts zoom to scale and vice versa and returns the same values",(function(){var o=e.getZoomScale(6.25,8.5);expect(Math.round(100*e.getScaleZoom(o,8.5))/100).to.eql(6.25)})),it("converts scale to zoom and returns Infinity if map crs.zoom returns NaN",(function(){sinon.stub(e.options.crs,"zoom").returns(NaN);expect(e.getScaleZoom(.25,8.5)).to.eql(1/0),e.options.crs.zoom.restore()}))})),describe("#getZoom",(function(){it("returns undefined if map not initialized",(function(){expect(e.getZoom()).to.be(void 0)})),it("returns undefined if map not initialized but layers added",(function(){e.addLayer(L.tileLayer("file:///dev/null")),expect(e.getZoom()).to.be(void 0)}))}))}));