describe("Map.Drag",(function(){describe("#addHook",(function(){it("calls the map with dragging enabled",(function(){var e=document.createElement("div"),t=new L.Map(e,{dragging:!0});expect(t.dragging.enabled()).to.be(!0),t.setView([0,0],0),expect(t.dragging.enabled()).to.be(!0)})),it("calls the map with dragging and worldCopyJump enabled",(function(){var e=document.createElement("div"),t=new L.Map(e,{dragging:!0,worldCopyJump:!0});expect(t.dragging.enabled()).to.be(!0),t.setView([0,0],0),expect(t.dragging.enabled()).to.be(!0)})),it("calls the map with dragging disabled and worldCopyJump enabled; enables dragging after setting center and zoom",(function(){var e=document.createElement("div"),t=new L.Map(e,{dragging:!1,worldCopyJump:!0});expect(t.dragging.enabled()).to.be(!1),t.setView([0,0],0),t.dragging.enable(),expect(t.dragging.enabled()).to.be(!0)}))})),describe("mouse events",(function(){var e;beforeEach((function(){(e=document.createElement("div")).style.width=e.style.height="600px",e.style.top=e.style.left=0,e.style.position="absolute",document.body.appendChild(e)})),afterEach((function(){document.body.removeChild(e)})),it("change the center of the map",(function(t){var n=new L.Map(e,{dragging:!0,inertia:!1});n.setView([0,0],1),new Hand({timing:"fastframe",onStop:function(){var e=n.getCenter(),o=n.getZoom();expect(e.lat).to.be.within(21.943,21.9431),expect(e.lng).to.be(-180),expect(o).to.be(1),t()}}).growFinger("mouse").wait(100).moveTo(200,200,0).down().moveBy(5,0,20).moveBy(256,32,200).up()})),it("does not change the center of the map when mouse is moved less than the drag threshold",(function(t){var n=new L.Map(e,{dragging:!0,inertia:!1}),o=L.latLng(0,0);n.setView(o,1);var i=sinon.spy();n.on("drag",i),new Hand({timing:"fastframe",onStop:function(){var e=n.getCenter(),a=n.getZoom();expect(e).to.be(o),expect(i.callCount).to.eql(0),expect(a).to.be(1),t()}}).growFinger("mouse").wait(100).moveTo(200,200,0).down().moveBy(1,0,20).moveBy(1,0,200).up()})),it("does not trigger preclick nor click",(function(t){var n=new L.Map(e,{dragging:!0,inertia:!1});n.setView([0,0],1);var o=sinon.spy(),i=sinon.spy(),a=sinon.spy();n.on("click",o),n.on("preclick",i),n.on("drag",a),new Hand({timing:"fastframe",onStop:function(){happen.click(e),expect(a.called).to.be(!0),expect(o.called).to.be(!1),expect(i.called).to.be(!1),t()}}).growFinger("mouse").wait(100).moveTo(200,200,0).down().moveBy(5,0,20).moveBy(256,32,200).up()})),it("does not trigger preclick nor click when dragging on top of a static marker",(function(t){var n=new L.Map(e,{dragging:!0,inertia:!1});n.setView([0,0],1);var o=L.marker(n.getCenter()).addTo(n),i=sinon.spy(),a=sinon.spy(),r=sinon.spy(),c=sinon.spy();n.on("click",i),n.on("preclick",a),n.on("drag",c),o.on("click",i),o.on("preclick",a),o.on("drag",r),new Hand({timing:"fastframe",onStop:function(){happen.click(e),expect(c.called).to.be(!0),expect(r.called).to.be(!1),expect(i.called).to.be(!1),expect(a.called).to.be(!1),t()}}).growFinger("mouse").moveTo(300,280,0).down().moveBy(5,0,20).moveBy(20,20,100).up()})),it("does not trigger preclick nor click when dragging a marker",(function(t){var n=new L.Map(e,{dragging:!0,inertia:!1});n.setView([0,0],1);var o=L.marker(n.getCenter(),{draggable:!0}).addTo(n),i=sinon.spy(),a=sinon.spy(),r=sinon.spy(),c=sinon.spy();n.on("click",i),n.on("preclick",a),n.on("drag",c),o.on("click",i),o.on("preclick",a),o.on("drag",r),new Hand({timing:"fastframe",onStop:function(){happen.click(o._icon),expect(r.called).to.be(!0),expect(c.called).to.be(!1),expect(i.called).to.be(!1),expect(a.called).to.be(!1),t()}}).growFinger("mouse").moveTo(300,280,0).down().moveBy(5,0,20).moveBy(50,50,100).up()})),it("does not change the center of the map when drag is disabled on click",(function(e){var t=document.createElement("div");t.style.width=t.style.height="600px",t.style.top=t.style.left=0,t.style.position="absolute",document.body.appendChild(t);var n=new L.Map(t,{dragging:!0,inertia:!1}),o=L.latLng(0,0);n.setView(o,1),n.on("mousedown",(function(){n.dragging.disable()}));var i=sinon.spy();n.on("drag",i),new Hand({timing:"fastframe",onStop:function(){var a=n.getCenter(),r=n.getZoom();document.body.removeChild(t),expect(a).to.be(o),expect(i.callCount).to.eql(0),expect(r).to.be(1),e()}}).growFinger("mouse").wait(100).moveTo(200,200,0).down().moveBy(5,0,20).moveBy(256,32,200).up()}))})),describe("touch events",(function(){it.skipIfNotTouch("change the center of the map",(function(e){var t=document.createElement("div");t.style.width=t.style.height="600px",t.style.top=t.style.left=0,t.style.position="absolute",document.body.appendChild(t);var n=new L.Map(t,{dragging:!0,inertia:!1});n.setView([0,0],1),new Hand({timing:"fastframe",onStop:function(){var o=n.getCenter(),i=n.getZoom();document.body.removeChild(t),expect(o.lat).to.be.within(21.943,21.9431),expect(o.lng).to.be(-180),expect(i).to.be(1),e()}}).growFinger("touch").wait(100).moveTo(200,200,0).down().moveBy(5,0,20).moveBy(256,32,200).up()})),it.skipIfNotTouch("does not change the center of the map when finger is moved less than the drag threshold",(function(e){var t=document.createElement("div");t.style.width=t.style.height="600px",t.style.top=t.style.left=0,t.style.position="absolute",document.body.appendChild(t);var n=new L.Map(t,{dragging:!0,inertia:!1}),o=L.latLng(0,0);n.setView(o,1);var i=sinon.spy();n.on("drag",i),new Hand({timing:"fastframe",onStop:function(){var a=n.getCenter(),r=n.getZoom();document.body.removeChild(t),expect(a).to.be(o),expect(i.callCount).to.eql(0),expect(r).to.be(1),e()}}).growFinger("touch").wait(100).moveTo(200,200,0).down().moveBy(1,0,20).moveBy(1,0,200).up()})),it.skipIfNotTouch("reset itself after touchend",(function(e){var t=document.createElement("div");t.style.width=t.style.height="600px",t.style.top=t.style.left=0,t.style.position="absolute",document.body.appendChild(t);var n=new L.Map(t,{dragging:!0,inertia:!1,zoomAnimation:!1});n.setView([0,0],1),n.dragging.disable(),n.dragging.enable();var o=n.getCenter(),i=n.getZoom(),a=new Hand({timing:"fastframe",onStop:function(){document.body.removeChild(t),expect(n.getCenter()).to.eql(o),expect(n.getZoom()).to.eql(i),e()}}).growFinger("mouse"),r=new Hand({timing:"fastframe",onStop:function(){expect(n.getCenter()).not.to.eql(o),expect(n.getZoom()).not.to.eql(i),o=n.getCenter(),i=n.getZoom(),a.moveTo(220,220,0).moveBy(200,0,2e3)}}),c=r.growFinger("touch"),g=r.growFinger("touch");r.sync(5),c.wait(100).moveTo(275,300,0).down().moveBy(-200,0,1e3).up(200),g.wait(110).moveTo(325,300,0).down().moveBy(210,0,1e3).up(200)}))}))}));